<?php

namespace XF2SEO\SEOPackage\XF\Pub\Controller;

use XF\Mvc\ParameterBag;
use XF2SEO\SEOPackage\App;
use XF2SEO\SEOPackage\ControllerPlugin\Metadata;

class Thread extends XFCP_Thread
{
    public function actionSEOMetadata(ParameterBag $params)
    {
        /** @var \XF2SEO\SEOPackage\XF\Entity\Thread $thread */
        $thread = $this->assertViewableThread($params['thread_id']);
        if (!$thread->canSEOPackageEdit($error)) {
            return $this->noPermission($error);
        }

        /** @var Metadata $metadataPlugin */
        $metadataPlugin = $this->plugin('XF2SEO\SEOPackage:Metadata');

        return $metadataPlugin->actionMetadata(
            $thread,
            $this->buildLink('threads/seo-metadata', $thread),
            $this->buildLink('threads', $thread),
            $thread->getBreadcrumbs(true)
        );
    }

    /**
     * @return string[]
     */
    protected function getThreadViewExtraWith()
    {
        $with = parent::getThreadViewExtraWith();
        $with[] = App::RELATION_METADATA;

        return $with;
    }
}
